import java.io.*;
import java.util.*;
import java.awt.image.*;


class BitmapExporter implements ImageConsumer {

  private ImageProducer ip;
  private PrintWriter out;

  private int nbSetBytePixels = 0;
  private int nbSetIntPixels = 0;

	
  public BitmapExporter(ImageProducer ip, PrintWriter out) {
    this.ip = ip;
    this.out = out;
  }

	
  public void imageComplete(int status) {
    ip.removeConsumer(this);
    out.close();
    System.out.println("Export done!");
    System.out.println("Nb of calls to setPixels(..., byte pixels[], ...): " +
		       nbSetBytePixels);
    System.out.println("Nb of calls to setPixels(..., int pixels[], ...): " +
		       nbSetIntPixels);
  }


  // called when color depth is 8 bits
  public void setPixels(int x,
                        int y,
                        int w,
                        int h,
                        ColorModel model,
                        byte pixels[],
                        int off,
                        int scansize) {

    for (int i = 0 ; i < pixels.length ; i++) {
      out.println(pixels[i]);
    }
		
    nbSetBytePixels++;
  }

		
  // called when color depth is more than 8 bits
  public void setPixels(int x,
                        int y,
                        int w,
                        int h,
                        ColorModel model,
                        int pixels[],
                        int off,
                        int scansize) {

    for (int i = 0 ; i < pixels.length ; i++) {
      int pixel = pixels[i];
      out.println(model.getRed(pixel) + " " +
		  model.getGreen(pixel) + " " +
		  model.getBlue(pixel));
    }
		
    nbSetIntPixels++;
  }


  public void setProperties(Hashtable props) {}
  public void setColorModel(ColorModel model) {}
  public void setDimensions(int width, int height) {}
  public void setHints(int hintflags) {}

}
