import java.awt.*;
import java.awt.event.*;


class GraphicButtonML implements MouseListener {

  private ToolPanel tp;
  

  public GraphicButtonML(ToolPanel tp) {

    this.tp = tp;
    
  }
  
 
  public void mousePressed(MouseEvent e) {
    
    Victor v = (Victor) tp.getParent();
		
    if (e.getSource() == tp.colorTool) {
      tp.colorSelector = new ColorSelector((Frame) v);
      tp.colorSelector.show();
    }
    else if (e.getSource() == tp.fillSwitchTool) {
      tp.fill = !tp.fill;
      if (tp.fill) {
	tp.rectangleTool.setType(GraphicButton.fillRect);
	tp.ellipseTool.setType(GraphicButton.fillOval);
	tp.polygonTool.setType(GraphicButton.fillPolygon);
      }
      else {
	tp.rectangleTool.setType(GraphicButton.drawRect);
	tp.ellipseTool.setType(GraphicButton.drawOval);
	tp.polygonTool.setType(GraphicButton.drawPolygon);
      }
      if (v.s.changeFillState()) {
	v.s.repaint();
      }
    }
    else {
      if (e.getSource() == tp.selectionTool) {
	v.s.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
      }
      else {
	// Shape tools
	v.s.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
      }

      (tp.buttons[tp.currentTool]).setState(false);
      for (byte i = 0 ; i < tp.buttons.length ; i++) {
	if (tp.buttons[i] == (GraphicButton) e.getSource()) {
	  tp.currentTool = i;
	  break;
	}
      }
      (tp.buttons[tp.currentTool]).setState(true);
    }

    if (v.s.currentPolygon.npoints != 0) {
      v.s.currentPoint = null;
      v.s.currentPolygon = new Polygon();
      v.s.repaint();
    }
		
    // Gotta give the focus to Sheet, otherwise "DEL" won't work.
    v.s.requestFocus();

  }

  public void mouseClicked(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}

}
