import java.awt.*;


class Grid {

  private int step;
  private Image image;


  public Grid(int step) {
		
    this.step = step;

  }


  public void setImage(Image image) {

    this.image = image;

  }

    
  public Image getImage(Component c) {

    if (image == null) {
      // Prepares an image of the grid:
      Dimension d = c.getSize();
      image = c.createImage(d.width, d.height);
      Graphics g = image.getGraphics();
      g.setColor(Color.black);

      int lineOffset = step * 10;
		
      // Horizontal lines:
      for (int y = 0 ; y < d.height ; y += lineOffset) {
	for (int x = 0 ; x < d.width ; x += step) {
	  g.drawLine(x, y, x, y);
	}
      }

      // Vertical lines:
      for (int x = 0 ; x < d.width ; x += lineOffset) {
	for (int y = 0 ; y < d.height ; y += step) {
	  g.drawLine(x, y, x, y);
	}
      }
    }

    return image;
		
  }


  public Point snap(Point p) {

    int x = Math.round((float) p.x / step) * step;
    int y = Math.round((float) p.y / step) * step;

    return new Point(x, y);

  }

}
