import java.awt.*;
import java.awt.event.*;
import java.io.*;


class MenuActionListener implements ActionListener {

  private Victor v;


  public MenuActionListener(Victor v) {
    
    this.v = v;
    
  }


  private void saveAs() {
    
    FileDialog fd = new FileDialog(v, "Save File As...", FileDialog.SAVE);
    if (v.s.getFilePath() != null) {
      fd.setDirectory(v.s.getFilePath());
    }
    // Ne marche pas :
    // fd.setFilenameFilter(new ExtFilenameFilter(".vic"));
    fd.show();

    String fileName = fd.getFile();
    if (fileName != null) {
      v.s.save(fd.getDirectory(), fileName);
    }
    
  }

  
  public void actionPerformed(ActionEvent e) {

    if (e.getSource() == v.newImage) {
      NewDialog newDialog = new NewDialog((Frame) v);
      newDialog.show();
    }
    else if (e.getSource() == v.open) {
      FileDialog fd = new FileDialog(v, "Open File...");
      if (v.s.getFilePath() != null) {
	fd.setDirectory(v.s.getFilePath());
      }
      // Ne marche pas :
      // fd.setFilenameFilter(new ExtFilenameFilter(".vic"));
      fd.show();

      String fileName = fd.getFile();
      if (fileName != null) {
	v.s.load(fd.getDirectory(), fileName);
      }
    }
    else if (e.getSource() == v.save) {
      if (v.s.getFileName() != null) {
	v.s.save(v.s.getFilePath(), v.s.getFileName());
      }
      else {
	saveAs();
      }
    }
    else if (e.getSource() == v.saveAs) {
      saveAs();
    }
//     else if (e.getSource() == v.export) {
//       FileDialog fd = new FileDialog(v, "Export To File...", FileDialog.SAVE);
//       // fd.setFilenameFilter(new ExtFilenameFilter(".vic"));
//       fd.show();

//       String fileName = fd.getFile();
//       if (fileName != null) {
// 	v.s.export(fd.getDirectory() + fileName);
//       }
//     }
    else if (e.getSource() == v.print) {
      v.s.print();
    }
    else if (e.getSource() == v.exit) {
      v.exit();
    }
    else if (e.getSource() == v.cut) {
      if (v.s.copyShapes(true)) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.copy) {
      v.s.copyShapes(false);
    }
    else if (e.getSource() == v.paste) {
      if (v.s.pasteShapes()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.delete) {
      if (v.s.deleteShapes() != 0) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.selectAll) {
      if (v.s.selectAll()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.foreground) {
      if (v.s.foreground()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.closer) {
      if (v.s.closer()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.farther) {
      if (v.s.farther()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.background) {
      if (v.s.background()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.align) {
      AlignDialog alignDialog = new AlignDialog((Frame) v);
      alignDialog.show();
    }
    else if (e.getSource() == v.rotate) {
      if (v.s.rotate()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.hMirror) {
      if (v.s.mirror(-1, 1)) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.vMirror) {
      if (v.s.mirror(1, -1)) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.group) {
      if (v.s.group()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.ungroup) {
      if (v.s.ungroup()) {
	v.s.repaint();
      }
    }
    else if (e.getSource() == v.about) {
      AboutDialog aboutDialog = new AboutDialog((Frame) v);
      aboutDialog.show();
    }
  }

}
