import java.awt.*;
import java.awt.event.*;


class NewDialog extends Dialog implements ActionListener {

  TextField widthValue, heightValue;
  OkCancelPanel ocp;
	

  public NewDialog(Frame f) {
		
    super(f, "New image", true);
    setLocation(60, 60);
    addWindowListener((WindowListener) new WindowWindowListener(this));

    GridBagLayout gridbag = new GridBagLayout();
    Panel p = new InsetsPanel(new Insets(0, 0, 10, 0), gridbag);
    GridBagConstraints gbc = new GridBagConstraints();    

    Victor v = (Victor) f;

    gbc.gridx = 0;
    gbc.anchor = GridBagConstraints.WEST;
    
    Label widthLabel = new Label("Width");
    gridbag.setConstraints(widthLabel, gbc);
    p.add(widthLabel);
    
    Label heightLabel = new Label("Height");
    gridbag.setConstraints(heightLabel, gbc);
    p.add(heightLabel);

    
    gbc.gridx = 1;
    
    widthValue = new TextField(String.valueOf(v.s.d.width), 5);
    gridbag.setConstraints(widthValue, gbc);
    p.add(widthValue);
    
    heightValue = new TextField(String.valueOf(v.s.d.height), 5);
    gridbag.setConstraints(heightValue, gbc);
    p.add(heightValue);
    

    ocp = new OkCancelPanel();
    ocp.ok.addActionListener(this);
    ocp.cancel.addActionListener(this);

    InsetsPanel mainPanel = new InsetsPanel(new Insets(10, 10, 10, 10),
					    new BorderLayout());
    mainPanel.add("Center", p);
    mainPanel.add("South", ocp);

    add(mainPanel);

    pack();
    
  }


  private Dimension getDimension() {

    int w, h;
    
    try {
      w = Integer.parseInt(widthValue.getText());
      h = Integer.parseInt(heightValue.getText());
    }
    catch (NumberFormatException nfe) {
      return null;
    }

    if ((w <= 0) || (h <= 0)) {
      return null;
    }
    else {
      return new Dimension(w, h);
    }
    
  }

  
  public void actionPerformed(ActionEvent e) {

    if (e.getSource() == ocp.ok) {
      Dimension d = getDimension();
      if (d != null) {
	setVisible(false);
	Victor v = (Victor) getParent();
	v.s.setFileName(null);
	if (!v.s.d.equals(d)) {
	  v.s.grid.setImage(null);
	}
	v.s.d = d;
	v.vcl.resizeSheet();
	v.s.deleteAllShapes();
	v.s.repaint();
	dispose();
      }
      else {
	Toolkit.getDefaultToolkit().beep();
      }
    }
    else if (e.getSource() == ocp.cancel) {
      setVisible(false);
      dispose();
    }
    
  }

}
