import java.awt.*;
import java.awt.event.*;


class SheetKeyListener implements KeyListener {
	
  private Sheet s;
  private boolean isShiftDown;


  public SheetKeyListener(Sheet s) {
    this.s = s;
    isShiftDown = false;
  }


  boolean isShiftDown() {
    return isShiftDown;
  }

	
  public void keyPressed(KeyEvent e) {
		
    if (e.getKeyCode() == KeyEvent.VK_DELETE) {
      if (s.deleteShapes() != 0) {
	s.repaint();
      }
    }
    else if (e.getKeyCode() == KeyEvent.VK_SHIFT) {
      // keyPressed() can be called repeatedly, because of key repetition.
      if (!isShiftDown) {
	isShiftDown = true;

	if ((s.v.tp.currentTool == ToolPanel.selection) &&
	    (s.anchor != null) &&
	    !s.areaSelection &&
	    (s.smml.previousPosition != null)) {

	  // There's a translation going on.

	  Point p = new Point(s.smml.mousePosition);
	  p = s.smml.translation(p);
	  s.smml.previousPosition = p;
	}
	else {				
	  s.repaint();
	}
      }
    }
  }


  public void keyReleased(KeyEvent e) {
		
    if (e.getKeyCode() == KeyEvent.VK_SHIFT) {
      isShiftDown = false;

      if ((s.v.tp.currentTool == ToolPanel.selection) &&
	  (s.anchor != null) &&
	  !s.areaSelection &&
	  (s.smml.previousPosition != null)) {

				// There's a translation going on.

	Point p = new Point(s.smml.mousePosition);
	if (s.v.snapToGrid.getState() == true) {
	  p = s.grid.snap(p);
	}

	if (s.sml.handleClicked != null) {
	  if (s.sml.extendedEditShape != null) {
	    if (s.sml.extendedEditShape instanceof PolygonShape) {
	      PolygonShape polygon = (PolygonShape) s.sml.extendedEditShape;
	      polygon.extendedEdit(s.smml.previousPosition, p);

	      int dx = p.x - s.smml.previousPosition.x;
	      int dy = p.y - s.smml.previousPosition.y;
	      s.sml.handleClicked.translate(dx, dy);
	    }
	  }
	  else {
	    s.sml.handleClicked.owner.reshape(s.sml.initialShape, s.anchor, p);
	    s.sml.handleClicked.owner.removeHandles();
	    s.sml.handleClicked.owner.createHandles();
	  }
	}
	else {
	  int dx = p.x - s.smml.previousPosition.x;
	  int dy = p.y - s.smml.previousPosition.y;
	  s.translateShapes(dx, dy);
	}
				
	s.smml.previousPosition = p;
      }
			
      s.repaint();
    }
		
  }

	
  public void keyTyped(KeyEvent e) {}
	
}
