import java.awt.*;


class ToolPanel extends InsetsPanel {

  GraphicButton
    selectionTool, lineTool, rectangleTool, ellipseTool,
    polygonTool, textTool, colorTool, fillSwitchTool;

  public static final byte selection = 0;
  public static final byte line      = 1;
  public static final byte rectangle = 2;
  public static final byte ellipse   = 3;
  public static final byte polygon   = 4;
  public static final byte text      = 5;

  GraphicButton[] buttons = new GraphicButton[6];
  
  ColorSelector colorSelector;
  byte currentTool;
  Color currentColor;
  boolean fill;


  public ToolPanel() {
    
    super(new Insets(5, 5, 0, 5));
    GridBagLayout gridbag = new GridBagLayout();
    setLayout(gridbag);
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    		
    currentColor = Color.black;
    fill = true;

    GraphicButtonML gbml = new GraphicButtonML(this);
    Dimension d = new Dimension(32, 32);

    selectionTool = new GraphicButton(GraphicButton.image,
				      "Icons/SelectionIcon.gif", true);
    buttons[selection] = selectionTool;
    selectionTool.setSize(d);
    gridbag.setConstraints(selectionTool, gbc);
    selectionTool.addMouseListener(gbml);
    add(selectionTool);

    currentTool = selection;
		
    lineTool = new GraphicButton(GraphicButton.line, false);
    buttons[line] = lineTool;
    lineTool.setSize(d);
    gridbag.setConstraints(lineTool, gbc);
    lineTool.addMouseListener(gbml);
    add(lineTool);
		
    rectangleTool = new GraphicButton(GraphicButton.fillRect, false);
    buttons[rectangle] = rectangleTool;
    rectangleTool.setSize(d);
    gridbag.setConstraints(rectangleTool, gbc);
    rectangleTool.addMouseListener(gbml);
    add(rectangleTool);

    ellipseTool = new GraphicButton(GraphicButton.fillOval, false);
    buttons[ellipse] = ellipseTool;
    ellipseTool.setSize(d);
    gridbag.setConstraints(ellipseTool, gbc);
    ellipseTool.addMouseListener(gbml);
    add(ellipseTool);

    polygonTool = new GraphicButton(GraphicButton.fillPolygon, false);
    buttons[polygon] = polygonTool;
    polygonTool.setSize(d);
    gridbag.setConstraints(polygonTool, gbc);
    polygonTool.addMouseListener(gbml);
    add(polygonTool);

    textTool = new GraphicButton(GraphicButton.text, false);
    buttons[text] = textTool;
    textTool.setSize(d);
    gridbag.setConstraints(textTool, gbc);
    textTool.addMouseListener(gbml);
    add(textTool);

    // On spare les outils restant car ils ne modifient pas l'outil courant :
    gbc.insets = new Insets(d.height, 0, 0, 0);
    colorTool = new GraphicButton(GraphicButton.empty, true);
    colorTool.setBackground(currentColor);
    colorTool.setSize(d);
    gridbag.setConstraints(colorTool, gbc);
    gbc.insets = new Insets(0, 0, 0, 0);
    colorTool.addMouseListener(gbml);
    add(colorTool);

    // Ces 2 valeurs, associes au dernier bouton de la barre d'outil,
    // permettent de caler tous les boutons en haut de la barre.
    gbc.weighty = 1.0;
    gbc.anchor = GridBagConstraints.NORTH;

    fillSwitchTool = new GraphicButton(GraphicButton.image,
				       "Icons/FillSwitchIcon.gif", false);
    fillSwitchTool.setSize(d);
    gridbag.setConstraints(fillSwitchTool, gbc);
    fillSwitchTool.addMouseListener(gbml);
    add(fillSwitchTool);

  }

}
