import java.awt.*;
import java.awt.event.*;


public class Victor extends Frame {

  String title = "Victor Grafeks";

  ToolPanel tp;
  Sheet s;

  MenuItem newImage;
  MenuItem open;
  MenuItem save;
  MenuItem saveAs;
  //  MenuItem export;
  MenuItem print;
  MenuItem exit;

  MenuItem cut;
  MenuItem copy;
  MenuItem paste;
  MenuItem delete;
  MenuItem selectAll;

  MenuItem foreground;
  MenuItem closer;
  MenuItem farther;
  MenuItem background;
  MenuItem align;
  MenuItem rotate;
  MenuItem hMirror;
  MenuItem vMirror;
  MenuItem group;
  MenuItem ungroup;

  CheckboxMenuItem grid;
  CheckboxMenuItem snapToGrid;

  MenuItem about;

  VicCompLis vcl;


  public Victor() {
  	
    super();
    setTitle(title);

    ActionListener al = (ActionListener) new MenuActionListener(this);
    ItemListener il = (ItemListener) new MenuItemListener(this);
		
    MenuBar mb = new MenuBar();

    /*************************************************************************/
    Menu fileMenu = new Menu("File");

    newImage = new MenuItem("New...", new MenuShortcut(KeyEvent.VK_N));
    newImage.addActionListener(al);
    fileMenu.add(newImage);
    
    open = new MenuItem("Open...");
    open.addActionListener(al);
    fileMenu.add(open);

    save = new MenuItem("Save", new MenuShortcut(KeyEvent.VK_S));
    save.addActionListener(al);
    fileMenu.add(save);
    
    saveAs = new MenuItem("Save as...");
    saveAs.addActionListener(al);
    fileMenu.add(saveAs);

    // export = new MenuItem("Export...");
//     export.addActionListener(al);
//     fileMenu.add(export);

    print = new MenuItem("Print...");
    print.addActionListener(al);
    fileMenu.add(print);
  	
    fileMenu.add(new MenuItem("-"));
		
    exit = new MenuItem("Exit");
    exit.addActionListener(al);
    fileMenu.add(exit);

    mb.add(fileMenu);

    /*************************************************************************/
    Menu editMenu = new Menu("Edit");

    cut = new MenuItem("Cut", new MenuShortcut(KeyEvent.VK_X));
    cut.addActionListener(al);
    cut.setEnabled(false);
    editMenu.add(cut);
  	
    copy = new MenuItem("Copy", new MenuShortcut(KeyEvent.VK_C));
    copy.addActionListener(al);
    copy.setEnabled(false);
    editMenu.add(copy);
  	
    paste = new MenuItem("Paste", new MenuShortcut(KeyEvent.VK_V));
    paste.addActionListener(al);
    paste.setEnabled(false);
    editMenu.add(paste);

    editMenu.add(new MenuItem("-"));

    delete = new MenuItem("Delete");
    delete.addActionListener(al);
    delete.setEnabled(false);
    editMenu.add(delete);

    selectAll = new MenuItem("Select all", new MenuShortcut(KeyEvent.VK_A));
    selectAll.addActionListener(al);
    editMenu.add(selectAll);
  	
    mb.add(editMenu);
  	
    /*************************************************************************/
    Menu objectMenu = new Menu("Object");

    foreground = new MenuItem("Foreground");
    foreground.addActionListener(al);
    foreground.setEnabled(false);
    objectMenu.add(foreground);
  	
    closer = new MenuItem("Closer");
    closer.addActionListener(al);
    closer.setEnabled(false);
    objectMenu.add(closer);

    farther = new MenuItem("Farther");
    farther.addActionListener(al);
    farther.setEnabled(false);
    objectMenu.add(farther);

    background = new MenuItem("Background");
    background.addActionListener(al);
    background.setEnabled(false);
    objectMenu.add(background);

    objectMenu.add(new MenuItem("-"));

    align = new MenuItem("Align...");
    align.addActionListener(al);
    align.setEnabled(false);
    objectMenu.add(align);

    objectMenu.add(new MenuItem("-"));

    rotate = new MenuItem("Rotate");
    rotate.addActionListener(al);
    rotate.setEnabled(false);
    objectMenu.add(rotate);

    hMirror = new MenuItem("Horizontal mirror");
    hMirror.addActionListener(al);
    hMirror.setEnabled(false);
    objectMenu.add(hMirror);

    vMirror = new MenuItem("Vertical mirror");
    vMirror.addActionListener(al);
    vMirror.setEnabled(false);
    objectMenu.add(vMirror);

    objectMenu.add(new MenuItem("-"));

    group = new MenuItem("Group");
    group.addActionListener(al);
    group.setEnabled(false);
    objectMenu.add(group);

    ungroup = new MenuItem("Ungroup");
    ungroup.addActionListener(al);
    ungroup.setEnabled(false);
    objectMenu.add(ungroup);
  	
    mb.add(objectMenu);

    /*************************************************************************/
    Menu optionsMenu = new Menu("Options");

    grid = new CheckboxMenuItem("Grid");
    grid.addItemListener(il);
    optionsMenu.add(grid);

    snapToGrid = new CheckboxMenuItem("Snap to grid");
    snapToGrid.addItemListener(il);
    optionsMenu.add(snapToGrid);

    mb.add(optionsMenu);

    /*************************************************************************/
    Menu helpMenu = new Menu("Help");

    about = new MenuItem("About Victor...");
    about.addActionListener(al);
    helpMenu.add(about);

    mb.setHelpMenu(helpMenu);
    mb.add(helpMenu);
    
  	
    setMenuBar(mb);
  	
    tp = new ToolPanel();
    add("West", tp);

    ScrollPane sp = new ScrollPane(ScrollPane.SCROLLBARS_ALWAYS);
    s = new Sheet(this);

    sp.add(s);
    add("Center", sp);

    addWindowListener((WindowListener) new VictorWindowListener(this));
    vcl = new VicCompLis(this);
    addComponentListener((ComponentListener) vcl);
    
  }


  public static void main(String[] args) {
  	
    Victor v;
  	
    v = new Victor();
    v.setSize(600, 450);
    v.setLocation(30, 30);
    v.show();

  }


  void exit() {
    
    setVisible(false);
    dispose();
    System.exit(0);
    
  }
  
}

